"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Self: true,
  optional: true,
  "boolean": true,
  number: true,
  string: true,
  integer: true,
  Null: true,
  Undefined: true,
  array: true,
  object: true,
  func: true,
  promise: true,
  max: true,
  min: true,
  regex: true,
  length: true,
  isOptional: true,
  isArrayElement: true,
  composeTypeToArray: true,
  Type: true
};
exports["default"] = exports.Type = exports.composeTypeToArray = exports.isArrayElement = exports.isOptional = exports.length = exports.regex = exports.min = exports.max = exports.promise = exports.func = exports.object = exports.array = exports.Undefined = exports.Null = exports.integer = exports.string = exports.number = exports["boolean"] = exports.optional = exports.Self = void 0;

var _util = require("./util");

Object.keys(_util).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _util[key];
    }
  });
});

var _validateObj;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var MAX_TYPE = 2048;
var ALL_TYPE = [1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048];
var Self = -1;
exports.Self = Self;
var optional = 1;
exports.optional = optional;
var _boolean = 2;
exports["boolean"] = _boolean;
var number = 4;
exports.number = number;
var string = 8;
exports.string = string;
var integer = 16;
exports.integer = integer;
var Null = 32;
exports.Null = Null;
var Undefined = 64;
exports.Undefined = Undefined;
var array = 128;
exports.array = array;
var object = 256;
exports.object = object;
var func = 512;
exports.func = func;
var promise = 1024;
exports.promise = promise;

var max = function max(value, a) {
  return a >= value;
};

exports.max = max;

var min = function min(value, a) {
  return a <= value;
};

exports.min = min;

var regex = function regex(value, regexExpress) {
  return regexExpress.test(value);
};

exports.regex = regex;

var length = function length(arrOrString, _ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      a = _ref2[0],
      _ref2$ = _ref2[1],
      b = _ref2$ === void 0 ? Number.POSITIVE_INFINITY : _ref2$;

  return arrOrString.length >= a && arrOrString.length <= b;
};

exports.length = length;

var isOptional = function isOptional() {
  return true;
};

exports.isOptional = isOptional;

var isArrayElement = function isArrayElement() {
  return true;
};

exports.isArrayElement = isArrayElement;
var validateObj = (_validateObj = {}, _defineProperty(_validateObj, optional, function () {
  return true;
}), _defineProperty(_validateObj, _boolean, _util.isBoolean), _defineProperty(_validateObj, number, _util.isNumber), _defineProperty(_validateObj, string, _util.isString), _defineProperty(_validateObj, integer, _util.isInteger), _defineProperty(_validateObj, Null, _util.isNull), _defineProperty(_validateObj, Undefined, _util.isUndefined), _defineProperty(_validateObj, array, _util.isArray), _defineProperty(_validateObj, object, _util.isObject), _defineProperty(_validateObj, func, _util.isFunction), _defineProperty(_validateObj, promise, _util.isPromise), _validateObj);

var composeTypeToArray = function composeTypeToArray(_composeNumber) {
  var arrayType = [];
  var composeNumber = _composeNumber;

  for (var i = 0; composeNumber > 0; i += 1) {
    var remander = composeNumber % 2;

    if (remander === 1) {
      arrayType.push(ALL_TYPE[i]);
    }

    composeNumber = Number.parseInt(composeNumber / 2, 10);
  }

  return arrayType;
};

exports.composeTypeToArray = composeTypeToArray;

var Type = /*#__PURE__*/function () {
  function Type(_schema) {
    _classCallCheck(this, Type);

    this.schema = _schema;
    this.listError = [];
  }
  /**
   * Validate function 'valueParam' is has type 'typeParam'
   * @param {array|object|string|number|...} valueParam value to check
   * @param {number} typeParam type is string, number, string | number,...
   * @param {string} key this is key path like profile.name
   * @param {object} wrapperObject object wrap valueParam
   */


  _createClass(Type, [{
    key: "validateRecusive",
    value: function validateRecusive(valueParam, typeParam, keyParam, wrapperObject) {
      var _this = this;

      var key = keyParam;

      if (wrapperObject === undefined && !(0, _util.isObject)(valueParam)) {
        // key is value if valueParam is not object
        key = valueParam;
      }

      var type = typeParam;

      if (typeParam instanceof Type) {
        type = type.schema;
      }

      var value = valueParam;

      if ((0, _util.isObject)(valueParam)) {
        // create clone object
        value = _objectSpread({}, valueParam);
      } else if ((0, _util.isArray)(valueParam)) {
        value = _toConsumableArray(valueParam);
      }

      if (type === optional) {
        return;
      }

      if (!value && type === Self) {
        return;
      }

      if ((0, _util.isFunction)(type)) {
        if (!(value instanceof type)) {
          this.listError.push({
            key: key,
            message: "'".concat(value, " is not instance of class ").concat(type.name, "'")
          });
        }

        return;
      }

      if ((0, _util.isArray)(type) && (0, _util.isArray)(type[0])) {
        // function test eg: max, min, length, isString, isOptional, ...
        if ((0, _util.isFunction)(type[0][0])) {
          var i = 0;
          var isArrayCheck = false;

          if (type[0][0] === isOptional) {
            var keyOfObject = key && (0, _util.isString)(key) ? key.split('.').pop() : undefined;
            var keyDesc = Object.getOwnPropertyDescriptor(wrapperObject || {}, keyOfObject);

            if (value === undefined && keyDesc === undefined) {
              // don't run for loop below
              i = Number.POSITIVE_INFINITY;
            }
          }

          type.forEach(function (_type) {
            // check function is [[isArray]]
            if (_type[0] === isArrayElement) {
              isArrayCheck = true;
            }
          });

          for (; i < type.length; i += 1) {
            // functionCheck is min, max, isString,...
            var functionCheck = type[i][0];
            var values = [value];

            if (isArrayCheck) {
              values = value;
            }

            if (!(0, _util.isArray)(values)) {
              this.listError.push({
                key: key,
                message: "'".concat(key, "' is not array in compare function")
              });
              break;
            }

            if (functionCheck.length === 3) {
              if (!functionCheck(null, null, values)) {
                this.listError.push({
                  key: key,
                  message: "".concat(functionCheck.name, "() return false in array check")
                });
                break;
              }
            }

            for (var j = 0; j < values.length; j += 1) {
              var valueOfValues = values[j];

              if (!functionCheck(valueOfValues, type[i][1], values)) {
                this.listError.push({
                  key: (0, _util.isArray)(key) ? valueOfValues : key,
                  message: "'".concat(valueOfValues, "' is not valid in compare function")
                });
              }
            }
          }
        } else if (type[0].indexOf(value) === -1) {
          // in array test
          this.listError.push({
            key: key,
            message: "'".concat(key, "' is not valid of ").concat(type[0])
          });
        }
      } else if ((0, _util.isArray)(type)) {
        // check array of type, eg: [string] is value of string
        if (type.length !== 1) {
          this.listError.push({
            key: key,
            message: 'array type not support'
          });
        }

        if (!(0, _util.isArray)(value)) {
          if (type && type[0] !== Self) {
            this.listError.push({
              key: key,
              message: "value of '".concat(key, "' is not array")
            });
          }
        } else {
          value.forEach(function (v) {
            _this.validateRecusive(v, type[0], key, valueParam);
          });
        }
      } else if ((0, _util.isObject)(value)) {
        if (!(0, _util.isObject)(type)) {
          if (type === Self) {
            this.validateRecusive(value, this.schema, keyParam, valueParam);
          } else {
            this.listError.push({
              key: key,
              message: "type not found on ".concat(key)
            });
          }
        } else {
          // set value key same key in type
          Object.keys(type).forEach(function (keyOfKey) {
            if (value[keyOfKey] === undefined) {
              value[keyOfKey] = undefined;
            }
          }); // validate object

          Object.keys(value).forEach(function (keyOfValue) {
            var path = key ? "".concat(key, ".").concat(keyOfValue) : keyOfValue;

            _this.validateRecusive(value[keyOfValue], type[keyOfValue], path, valueParam);
          });
        }
      } else if ((0, _util.isNumber)(type) && type < MAX_TYPE * 2) {
        // validate compose type, eg: string | number
        var arrayType = composeTypeToArray(type);
        var validateResult = false;
        arrayType.forEach(function (aType) {
          if (validateObj[aType](value)) {
            validateResult = true;
          }
        });

        if (validateResult === false) {
          this.listError.push({
            key: key,
            message: "'".concat(key, "' is not valid type")
          });
        }
      } else {
        this.listError.push({
          key: key,
          message: "type of '".concat(key, "' not found")
        });
      }
    }
  }, {
    key: "validate",
    value: function validate(value) {
      this.listError = [];
      this.validateRecusive(value, this.schema);
      return this.listError;
    }
  }, {
    key: "assert",
    value: function assert(value) {
      this.listError = [];
      this.validateRecusive(value, this.schema);

      if (this.listError.length !== 0) {
        var message = this.listError.map(function (e) {
          return e.message;
        }).join('\n');
        throw new Error(message);
      }
    }
  }]);

  return Type;
}();

exports.Type = Type;
var _default = Type;
exports["default"] = _default;