"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNumber = isNumber;
exports.isBoolean = isBoolean;
exports.isString = isString;
exports.isFunction = isFunction;
exports.isSymbol = isSymbol;
exports.isObject = isObject;
exports.isArray = isArray;
exports.isNaN = isNaN;
exports.isEmptyObject = isEmptyObject;
exports.isEmptyArray = isEmptyArray;
exports.isPromise = isPromise;
exports.isRegex = isRegex;
exports.isBigInt = isBigInt;
exports.isInteger = exports.isUndefined = exports.isNull = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function isNumber(value) {
  return typeof value === 'number' && Number.isFinite(value);
}

function isBoolean(value) {
  return value === true || value === false;
}

function isString(value) {
  return typeof value === 'string';
} // check is function or class


function isFunction(value) {
  return typeof value === 'function';
}

function isSymbol(value) {
  return _typeof(value) === 'symbol';
} // check is normal object not array, date,...


function isObject(value) {
  return value && _typeof(value) === 'object' && value.constructor === Object;
}

function isArray(value) {
  return Array.isArray(value);
}

function isNaN(value) {
  return typeof value === 'number' && Number.isNaN(value);
}

var isNull = function isNull(value) {
  return value === null;
};

exports.isNull = isNull;

var isUndefined = function isUndefined(value) {
  return value === undefined;
};

exports.isUndefined = isUndefined;
var isInteger = Number.isInteger;
exports.isInteger = isInteger;

function isEmptyObject(value) {
  return isObject(value) && Object.keys(value).length === 0;
}

function isEmptyArray(value) {
  return isArray(value) && value.length === 0;
}

function isPromise(value) {
  return value && "".concat(value) === '[object Promise]';
}

function isRegex(value) {
  return value.constructor === RegExp;
}

function isBigInt(value) {
  return typeof value === 'bigint';
}